package com.gzlh.camera.handler.impl;

import com.gzlh.camera.brand.CameraBrandType;
import com.gzlh.camera.client.CameraNettyConfig;
import com.gzlh.camera.handler.ICameraHandler;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * 上海仰邦科技股份有限公司BX-5(M)K/6K（YY）-V4.2 led发送处理器
 */
@Service
@Slf4j
public class CameraHandlerHikvision implements ICameraHandler {

    @Resource
    private CameraNettyConfig cameraNettyConfig;

    @Override
    public CameraBrandType brandType() {
        return CameraBrandType.HIKVISION;
    }

    @Override
    public void sendMsg(String content) {
        log.info(CameraBrandType.HIKVISION.getBrand() + "发送消息:{}", content);
        cameraNettyConfig.send(content);
    }

    @Override
    public void handlerAction(String action) {
        log.info("action:{}",action);
    }
}
