package com.gzlh.gate.factory;



import com.gzlh.gate.handler.IGateHandler;
import com.gzlh.led.handler.ILedHandler;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class GateFactory {
    @Autowired
    private List<IGateHandler>handlers;

    public IGateHandler handler(int code){
       return handlers.stream().filter(h->h.brandType().getCode()==code)
                .findAny().orElseThrow(()->new IllegalArgumentException("不支持相机"));
    }

}
