package com.gzlh.gate.task;

import cn.hutool.core.codec.Base64;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.io.FileUtil;
import cn.hutool.core.util.RandomUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.extra.spring.SpringUtil;

import com.gzlh.config.FilePropertiesConfig;
import com.gzlh.task.Task;
import lombok.extern.slf4j.Slf4j;

import java.io.File;

@Slf4j
public class GateBase64ToImage extends Task {
    private String base64;
    private String carNo;
    public GateBase64ToImage(String id, long delayInMilliseconds, String base64,String carNo) {
        super(id, delayInMilliseconds);
        this.base64=base64;
        this.carNo=carNo;
    }

    @Override
    public void run() {
        if (StrUtil.isEmpty(base64)) {
            log.info("无图片信息--------");
            return;
        }
        String separator=File.separator;
        String fileTypeFolder = separator+"gate"+separator;
        String currDateFolder = DateUtil.today()+separator;
        String fileName = carNo+"-"+RandomUtil.randomNumbers(5) + ".jpg";
        FilePropertiesConfig filePropertiesConfig=SpringUtil.getBean(FilePropertiesConfig.class);
        String imgFilePath=filePropertiesConfig.getRootPath()+fileTypeFolder+currDateFolder;
        if (!FileUtil.exist(imgFilePath)) {
            FileUtil.mkdir(imgFilePath);
        }
        // 对外暴露的http路径
        Base64.decodeToFile(base64,new File(imgFilePath + fileName));

    }
}
