package com.gzlh.utils;

import org.springframework.beans.factory.annotation.Value;

import java.io.*;
import java.net.URL;
import java.net.URLConnection;
import java.util.Arrays;
import java.util.Base64;
import java.util.Calendar;

public class FileUtils {


    public static String downLoad(String urlString,String savePath) throws IOException {
        InputStream in = null;
        OutputStream out=null;

        try {
            URL url = new URL(urlString);
            URLConnection connection = url.openConnection();
            in = connection.getInputStream();
//            Calendar calendar = Calendar.getInstance();
//            String savePath=path+"/"+ calendar.get(Calendar.YEAR)+"-" + (calendar.get(Calendar.MONTH)+1);
            File folder = new File(savePath);
            if (!folder.exists()) {
                folder.mkdirs();
            }
            String fileName = new File(url.getFile()).getName();
            out = new FileOutputStream(savePath+"/"+fileName);

            byte[] buffer = new byte[1024];
            int bytesRead;
            while ((bytesRead = in.read(buffer)) != -1) {
                out.write(buffer, 0, bytesRead);
            }
            System.out.println("文件下载完成！");
            return savePath+"/"+fileName;
        } catch (Exception e) {
            throw e;
        }finally {
            if (in != null) {
                in.close();
            }
            if (out != null){
                out.close();
            }
        }

    }


    public static String getBase64FromImg(String filePath) throws IOException {
        FileInputStream in = null;
        try {
            File file = new File(filePath);
            // base64图片前缀
            String pre = "data:image/jpg;base64,";
            // 读取图片
            in = new FileInputStream(file);
            // 读取字节长度
            int len = 0;
            // baseByte数组的容量
            int capacity = 0;
            byte[] baseByte= new byte[0];
            byte [] bytes = new byte[1024];
            while ((len = in.read(bytes)) != -1){
                // 对原数组进行拷贝扩容
                baseByte= Arrays.copyOf(baseByte, len + capacity);
                // 将新数据拷贝到新扩容的数组
                System.arraycopy(bytes, 0, baseByte, capacity, len);
                // 数据容量增加
                capacity += len;
            }
            // 获取base64编码器
            Base64.Encoder encoder = Base64.getEncoder();
            // 将字节数组转换base64
            String encodeToString = encoder.encodeToString(baseByte);
//            System.out.println("======>>>>>>：" + pre + encodeToString);
            return pre + encodeToString;
        } catch (IOException e) {
            throw e;
        } finally {
            if (in != null) {
                in.close();
            }
        }

    }

}
